CREATE TABLE BPM_DATABASE_PROPERTY
(
  DBP_ID     NUMBER(10)                             NULL,
  DBP_APP    VARCHAR2(250 CHAR)                     NULL,
  DBP_KEY    VARCHAR2(250 CHAR)                     NULL,
  DBP_VALUE  VARCHAR2(1024 CHAR)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_DOCUMENT
(
  DOC_ID             NUMBER(19)                 NOT NULL,
  DOC_MIME_TYPE      VARCHAR2(255 CHAR)         NOT NULL,
  DOC_EXTERNAL_NAME  VARCHAR2(255 CHAR)             NULL,
  DOC_HASH           VARCHAR2(255 CHAR)             NULL,
  DOC_FS_PATH        VARCHAR2(255 CHAR)         NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_FILE_SYSTEM
(
  FIL_ID           NUMBER(19)                   NOT NULL,
  FIL_APPLICATION  VARCHAR2(255 CHAR)           NOT NULL,
  FIL_YEAR         NUMBER(10)                   NOT NULL,
  FIL_NEXT_DOC     NUMBER(19)                   NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_PROC_DEF_PROPERTIES
(
  PDP_ID                     NUMBER(10)         NOT NULL,
  PDP_PROCESS_DEFINITION_ID  NUMBER(10)         NOT NULL,
  PDP_NAME                   VARCHAR2(1000 CHAR) NOT NULL,
  PDP_VALUE                  VARCHAR2(1000 CHAR)     NULL
)
LOGGING 
NOCACHE
NOPARALLEL;

CREATE TABLE BPM_PROCESS_DEFINITION_ROLES
(
  PDR_PROCESS_DEFINITION_ID  NUMBER(10)         NOT NULL,
  PDR_APP_ROLE               VARCHAR2(250 CHAR)     NULL,
  PDR_USER_ROLE              VARCHAR2(250 CHAR)     NULL,
  PDR_IS_USER                NUMBER(1)              NULL,
  PDR_ID                     NUMBER(10)             NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_PROCESS_DEFINTION_ROLES
(
  PDR_ID                     NUMBER(10)             NULL,
  PDR_PROCESS_DEFINITION_ID  NUMBER(10)             NULL,
  PDR_APP_ROLE               VARCHAR2(250 CHAR)     NULL,
  PDR_USER_ROLE              VARCHAR2(250 CHAR)     NULL,
  PDR_IS_USER                NUMBER(1)              NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_PROCESS_FILE
(
  PRO_ID           NUMBER(10)                       NULL,
  PRO_INSTANCE_ID  NUMBER(10)                   NOT NULL,
  PRO_DOC_ID       NUMBER(10)                   NOT NULL,
  PRO_DOC_HASH     VARCHAR2(250 CHAR)           NOT NULL,
  PRO_DELETED      NUMBER(1)                    NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_ROLE
(
  ROL_ID    NUMBER(19)                          NOT NULL,
  ROL_NAME  VARCHAR2(255 CHAR)                  NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_SIGN
(
  SIG_ID         NUMBER(19)                     NOT NULL,
  SIG_SIGN_TYPE  CHAR(1 CHAR)                   NOT NULL,
  SIG_FS_PATH    VARCHAR2(255 CHAR)             NOT NULL,
  SIG_TIMESTAMP  DATE                           NOT NULL,
  SIG_DOC_ID     NUMBER(19)                     NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_USER_INTERFACE
(
  USI_ID                  NUMBER(10)                NULL,
  USI_TASK_NAME           VARCHAR2(250 CHAR)        NULL,
  USI_FILE_NAME           VARCHAR2(2048 CHAR)       NULL,
  USI_PROCESS_DEFINITION  INTEGER                   NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_USER_INTERFACE_CLASS
(
  USC_ID          NUMBER(10)                        NULL,
  USC_USI_ID      NUMBER(10)                    NOT NULL,
  USC_CLASS_NAME  VARCHAR2(250 CHAR)            NOT NULL,
  USC_CLASS       BLOB                              NULL
)
TABLESPACE IBKEY
LOB (USC_CLASS) STORE AS IBK_BPM_U_INT_CLASS_USC_LOB
(TABLESPACE IBKEY_LOB
INDEX IBK_BPM_U_INT_CLASS_USC_LOB_I)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE JBPM_BYTEARRAY
(
  ID_              NUMBER(19)                   NOT NULL,
  NAME_            VARCHAR2(255 CHAR)               NULL,
  FILEDEFINITION_  NUMBER(19)                       NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_BYTEBLOCK
(
  PROCESSFILE_  NUMBER(19)                      NOT NULL,
  BYTES_        RAW(1024)                           NULL,
  INDEX_        NUMBER(10)                      NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_DELEGATION
(
  ID_                 NUMBER(19)                NOT NULL,
  CLASSNAME_          VARCHAR2(4000 CHAR)           NULL,
  CONFIGURATION_      VARCHAR2(4000 CHAR)           NULL,
  CONFIGTYPE_         VARCHAR2(255 CHAR)            NULL,
  PROCESSDEFINITION_  NUMBER(19)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_EXCEPTIONHANDLER
(
  ID_                  NUMBER(19)               NOT NULL,
  EXCEPTIONCLASSNAME_  VARCHAR2(4000 CHAR)          NULL,
  TYPE_                CHAR(1 CHAR)                 NULL,
  GRAPHELEMENT_        NUMBER(19)                   NULL,
  PROCESSDEFINITION_   NUMBER(19)                   NULL,
  GRAPHELEMENTINDEX_   NUMBER(10)                   NULL,
  NODE_                NUMBER(19)                   NULL,
  TRANSITION_          NUMBER(19)                   NULL,
  TASK_                NUMBER(19)                   NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_ID_GROUP
(
  ID_      NUMBER(19)                           NOT NULL,
  CLASS_   CHAR(1 CHAR)                         NOT NULL,
  NAME_    VARCHAR2(255 CHAR)                       NULL,
  TYPE_    VARCHAR2(255 CHAR)                       NULL,
  PARENT_  NUMBER(19)                               NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_ID_PERMISSIONS
(
  ENTITY_  NUMBER(19)                           NOT NULL,
  CLASS_   VARCHAR2(255 CHAR)                       NULL,
  NAME_    VARCHAR2(255 CHAR)                       NULL,
  ACTION_  VARCHAR2(255 CHAR)                       NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_ID_USER
(
  ID_        NUMBER(19)                         NOT NULL,
  CLASS_     CHAR(1 CHAR)                       NOT NULL,
  NAME_      VARCHAR2(255 CHAR)                     NULL,
  EMAIL_     VARCHAR2(255 CHAR)                     NULL,
  PASSWORD_  VARCHAR2(255 CHAR)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TASKCONTROLLER
(
  ID_                        NUMBER(19)         NOT NULL,
  TASKCONTROLLERDELEGATION_  NUMBER(19)             NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE BPM_ACCESS_LOG
(
  ACC_ID       NUMBER(19)                       NOT NULL,
  ACC_TYPE     CHAR(1 CHAR)                     NOT NULL,
  ACC_DOC_ID   NUMBER(19)                       NOT NULL,
  ACC_USER     VARCHAR2(255 CHAR)               NOT NULL,
  ACC_DATE     TIMESTAMP(6)                     NOT NULL,
  ACC_ROLE_ID  NUMBER(19)                           NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE BPM_PERMISSION
(
  PER_DOC_ID  NUMBER(19)                        NOT NULL,
  PER_ROL_ID  NUMBER(19)                        NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL;


CREATE TABLE JBPM_ID_MEMBERSHIP
(
  ID_     NUMBER(19)                            NOT NULL,
  CLASS_  CHAR(1 CHAR)                          NOT NULL,
  NAME_   VARCHAR2(255 CHAR)                        NULL,
  ROLE_   VARCHAR2(255 CHAR)                        NULL,
  USER_   NUMBER(19)                                NULL,
  GROUP_  NUMBER(19)                                NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_ACTION
(
  ID_                     NUMBER(19)            NOT NULL,
  CLASS                   CHAR(1 CHAR)          NOT NULL,
  NAME_                   VARCHAR2(255 CHAR)        NULL,
  ISPROPAGATIONALLOWED_   NUMBER(1)                 NULL,
  ACTIONEXPRESSION_       VARCHAR2(255 CHAR)        NULL,
  ISASYNC_                NUMBER(1)                 NULL,
  REFERENCEDACTION_       NUMBER(19)                NULL,
  ACTIONDELEGATION_       NUMBER(19)                NULL,
  EVENT_                  NUMBER(19)                NULL,
  PROCESSDEFINITION_      NUMBER(19)                NULL,
  TIMERNAME_              VARCHAR2(255 CHAR)        NULL,
  DUEDATE_                VARCHAR2(255 CHAR)        NULL,
  REPEAT_                 VARCHAR2(255 CHAR)        NULL,
  TRANSITIONNAME_         VARCHAR2(255 CHAR)        NULL,
  TIMERACTION_            NUMBER(19)                NULL,
  EXPRESSION_             VARCHAR2(4000 CHAR)       NULL,
  EVENTINDEX_             NUMBER(10)                NULL,
  EXCEPTIONHANDLER_       NUMBER(19)                NULL,
  EXCEPTIONHANDLERINDEX_  NUMBER(10)                NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_COMMENT
(
  ID_                 NUMBER(19)                NOT NULL,
  VERSION_            NUMBER(10)                NOT NULL,
  ACTORID_            VARCHAR2(255 CHAR)            NULL,
  TIME_               TIMESTAMP(6)                  NULL,
  MESSAGE_            VARCHAR2(4000 CHAR)           NULL,
  TOKEN_              NUMBER(19)                    NULL,
  TASKINSTANCE_       NUMBER(19)                    NULL,
  TOKENINDEX_         NUMBER(10)                    NULL,
  TASKINSTANCEINDEX_  NUMBER(10)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_DECISIONCONDITIONS
(
  DECISION_        NUMBER(19)                   NOT NULL,
  TRANSITIONNAME_  VARCHAR2(255 CHAR)               NULL,
  EXPRESSION_      VARCHAR2(255 CHAR)               NULL,
  INDEX_           NUMBER(10)                   NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_EVENT
(
  ID_                 NUMBER(19)                NOT NULL,
  EVENTTYPE_          VARCHAR2(255 CHAR)            NULL,
  TYPE_               CHAR(1 CHAR)                  NULL,
  GRAPHELEMENT_       NUMBER(19)                    NULL,
  PROCESSDEFINITION_  NUMBER(19)                    NULL,
  NODE_               NUMBER(19)                    NULL,
  TRANSITION_         NUMBER(19)                    NULL,
  TASK_               NUMBER(19)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_LOG
(
  ID_                NUMBER(19)                 NOT NULL,
  CLASS_             CHAR(1 CHAR)               NOT NULL,
  INDEX_             NUMBER(10)                     NULL,
  DATE_              TIMESTAMP(6)                   NULL,
  TOKEN_             NUMBER(19)                     NULL,
  PARENT_            NUMBER(19)                     NULL,
  MESSAGE_           VARCHAR2(4000 CHAR)            NULL,
  EXCEPTION_         VARCHAR2(4000 CHAR)            NULL,
  ACTION_            NUMBER(19)                     NULL,
  NODE_              NUMBER(19)                     NULL,
  ENTER_             TIMESTAMP(6)                   NULL,
  LEAVE_             TIMESTAMP(6)                   NULL,
  DURATION_          NUMBER(19)                     NULL,
  NEWLONGVALUE_      NUMBER(19)                     NULL,
  TRANSITION_        NUMBER(19)                     NULL,
  CHILD_             NUMBER(19)                     NULL,
  SOURCENODE_        NUMBER(19)                     NULL,
  DESTINATIONNODE_   NUMBER(19)                     NULL,
  VARIABLEINSTANCE_  NUMBER(19)                     NULL,
  OLDBYTEARRAY_      NUMBER(19)                     NULL,
  NEWBYTEARRAY_      NUMBER(19)                     NULL,
  OLDDATEVALUE_      TIMESTAMP(6)                   NULL,
  NEWDATEVALUE_      TIMESTAMP(6)                   NULL,
  OLDDOUBLEVALUE_    FLOAT(126)                     NULL,
  NEWDOUBLEVALUE_    FLOAT(126)                     NULL,
  OLDLONGIDCLASS_    VARCHAR2(255 CHAR)             NULL,
  OLDLONGIDVALUE_    NUMBER(19)                     NULL,
  NEWLONGIDCLASS_    VARCHAR2(255 CHAR)             NULL,
  NEWLONGIDVALUE_    NUMBER(19)                     NULL,
  OLDSTRINGIDCLASS_  VARCHAR2(255 CHAR)             NULL,
  OLDSTRINGIDVALUE_  VARCHAR2(255 CHAR)             NULL,
  NEWSTRINGIDCLASS_  VARCHAR2(255 CHAR)             NULL,
  NEWSTRINGIDVALUE_  VARCHAR2(255 CHAR)             NULL,
  OLDLONGVALUE_      NUMBER(19)                     NULL,
  OLDSTRINGVALUE_    VARCHAR2(4000 CHAR)            NULL,
  NEWSTRINGVALUE_    VARCHAR2(4000 CHAR)            NULL,
  TASKINSTANCE_      NUMBER(19)                     NULL,
  TASKACTORID_       VARCHAR2(255 CHAR)             NULL,
  TASKOLDACTORID_    VARCHAR2(255 CHAR)             NULL,
  SWIMLANEINSTANCE_  NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_MESSAGE
(
  ID_              NUMBER(19)                   NOT NULL,
  CLASS_           CHAR(1 CHAR)                 NOT NULL,
  DESTINATION_     VARCHAR2(255 CHAR)               NULL,
  EXCEPTION_       VARCHAR2(4000 CHAR)              NULL,
  ISSUSPENDED_     NUMBER(1)                        NULL,
  TOKEN_           NUMBER(19)                       NULL,
  TEXT_            VARCHAR2(255 CHAR)               NULL,
  ACTION_          NUMBER(19)                       NULL,
  NODE_            NUMBER(19)                       NULL,
  TRANSITIONNAME_  VARCHAR2(255 CHAR)               NULL,
  TASKINSTANCE_    NUMBER(19)                       NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;

CREATE TABLE JBPM_MODULEDEFINITION
(
  ID_                 NUMBER(19)                NOT NULL,
  CLASS_              CHAR(1 CHAR)              NOT NULL,
  NAME_               VARCHAR2(4000 CHAR)           NULL,
  PROCESSDEFINITION_  NUMBER(19)                    NULL,
  STARTTASK_          NUMBER(19)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_MODULEINSTANCE
(
  ID_                  NUMBER(19)               NOT NULL,
  CLASS_               CHAR(1 CHAR)             NOT NULL,
  PROCESSINSTANCE_     NUMBER(19)                   NULL,
  TASKMGMTDEFINITION_  NUMBER(19)                   NULL,
  NAME_                VARCHAR2(255 CHAR)           NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_NODE
(
  ID_                    NUMBER(19)             NOT NULL,
  CLASS_                 CHAR(1 CHAR)           NOT NULL,
  NAME_                  VARCHAR2(255 CHAR)         NULL,
  PROCESSDEFINITION_     NUMBER(19)                 NULL,
  ISASYNC_               NUMBER(1)                  NULL,
  ACTION_                NUMBER(19)                 NULL,
  SUPERSTATE_            NUMBER(19)                 NULL,
  SUBPROCESSDEFINITION_  NUMBER(19)                 NULL,
  DECISIONEXPRESSION_    VARCHAR2(255 CHAR)         NULL,
  DECISIONDELEGATION     NUMBER(19)                 NULL,
  SIGNAL_                NUMBER(10)                 NULL,
  CREATETASKS_           NUMBER(1)                  NULL,
  ENDTASKS_              NUMBER(1)                  NULL,
  NODECOLLECTIONINDEX_   NUMBER(10)                 NULL,
  PARENTLOCKMODE_        VARCHAR2(255 CHAR)         NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_POOLEDACTOR
(
  ID_                NUMBER(19)                 NOT NULL,
  ACTORID_           VARCHAR2(255 CHAR)             NULL,
  SWIMLANEINSTANCE_  NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_PROCESSDEFINITION
(
  ID_                     NUMBER(19)            NOT NULL,
  NAME_                   VARCHAR2(255 CHAR)        NULL,
  VERSION_                NUMBER(10)                NULL,
  ISTERMINATIONIMPLICIT_  NUMBER(1)                 NULL,
  STARTSTATE_             NUMBER(19)                NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_PROCESSINSTANCE
(
  ID_                 NUMBER(19)                NOT NULL,
  VERSION_            NUMBER(10)                NOT NULL,
  START_              TIMESTAMP(6)                  NULL,
  END_                TIMESTAMP(6)                  NULL,
  ISSUSPENDED_        NUMBER(1)                     NULL,
  PROCESSDEFINITION_  NUMBER(19)                    NULL,
  ROOTTOKEN_          NUMBER(19)                    NULL,
  SUPERPROCESSTOKEN_  NUMBER(19)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_RUNTIMEACTION
(
  ID_                    NUMBER(19)             NOT NULL,
  VERSION_               NUMBER(10)             NOT NULL,
  EVENTTYPE_             VARCHAR2(255 CHAR)         NULL,
  TYPE_                  CHAR(1 CHAR)               NULL,
  GRAPHELEMENT_          NUMBER(19)                 NULL,
  PROCESSINSTANCE_       NUMBER(19)                 NULL,
  ACTION_                NUMBER(19)                 NULL,
  PROCESSINSTANCEINDEX_  NUMBER(10)                 NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_SWIMLANE
(
  ID_                      NUMBER(19)           NOT NULL,
  NAME_                    VARCHAR2(255 CHAR)       NULL,
  ACTORIDEXPRESSION_       VARCHAR2(255 CHAR)       NULL,
  POOLEDACTORSEXPRESSION_  VARCHAR2(255 CHAR)       NULL,
  ASSIGNMENTDELEGATION_    NUMBER(19)               NULL,
  TASKMGMTDEFINITION_      NUMBER(19)               NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_SWIMLANEINSTANCE
(
  ID_                NUMBER(19)                 NOT NULL,
  NAME_              VARCHAR2(255 CHAR)             NULL,
  ACTORID_           VARCHAR2(255 CHAR)             NULL,
  SWIMLANE_          NUMBER(19)                     NULL,
  TASKMGMTINSTANCE_  NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TASK
(
  ID_                      NUMBER(19)           NOT NULL,
  NAME_                    VARCHAR2(255 CHAR)       NULL,
  PROCESSDEFINITION_       NUMBER(19)               NULL,
  DESCRIPTION_             VARCHAR2(4000 CHAR)      NULL,
  ISBLOCKING_              NUMBER(1)                NULL,
  ISSIGNALLING_            NUMBER(1)                NULL,
  DUEDATE_                 VARCHAR2(255 CHAR)       NULL,
  ACTORIDEXPRESSION_       VARCHAR2(255 CHAR)       NULL,
  POOLEDACTORSEXPRESSION_  VARCHAR2(255 CHAR)       NULL,
  TASKMGMTDEFINITION_      NUMBER(19)               NULL,
  TASKNODE_                NUMBER(19)               NULL,
  STARTSTATE_              NUMBER(19)               NULL,
  ASSIGNMENTDELEGATION_    NUMBER(19)               NULL,
  SWIMLANE_                NUMBER(19)               NULL,
  TASKCONTROLLER_          NUMBER(19)               NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TASKACTORPOOL
(
  TASKINSTANCE_  NUMBER(19)                     NOT NULL,
  POOLEDACTOR_   NUMBER(19)                     NOT NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TASKINSTANCE
(
  ID_                NUMBER(19)                 NOT NULL,
  CLASS_             CHAR(1 CHAR)               NOT NULL,
  NAME_              VARCHAR2(255 CHAR)             NULL,
  DESCRIPTION_       VARCHAR2(4000 CHAR)            NULL,
  ACTORID_           VARCHAR2(255 CHAR)             NULL,
  CREATE_            TIMESTAMP(6)                   NULL,
  START_             TIMESTAMP(6)                   NULL,
  END_               TIMESTAMP(6)                   NULL,
  DUEDATE_           TIMESTAMP(6)                   NULL,
  PRIORITY_          NUMBER(10)                     NULL,
  ISCANCELLED_       NUMBER(1)                      NULL,
  ISSUSPENDED_       NUMBER(1)                      NULL,
  ISOPEN_            NUMBER(1)                      NULL,
  ISSIGNALLING_      NUMBER(1)                      NULL,
  ISBLOCKING_        NUMBER(1)                      NULL,
  TASK_              NUMBER(19)                     NULL,
  TOKEN_             NUMBER(19)                     NULL,
  SWIMLANINSTANCE_   NUMBER(19)                     NULL,
  TASKMGMTINSTANCE_  NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TIMER
(
  ID_                NUMBER(19)                 NOT NULL,
  NAME_              VARCHAR2(255 CHAR)             NULL,
  DUEDATE_           TIMESTAMP(6)                   NULL,
  REPEAT_            VARCHAR2(255 CHAR)             NULL,
  TRANSITIONNAME_    VARCHAR2(255 CHAR)             NULL,
  EXCEPTION_         VARCHAR2(4000 CHAR)            NULL,
  ISSUSPENDED_       NUMBER(1)                      NULL,
  ACTION_            NUMBER(19)                     NULL,
  TOKEN_             NUMBER(19)                     NULL,
  PROCESSINSTANCE_   NUMBER(19)                     NULL,
  TASKINSTANCE_      NUMBER(19)                     NULL,
  GRAPHELEMENTTYPE_  VARCHAR2(255 CHAR)             NULL,
  GRAPHELEMENT_      NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TOKEN
(
  ID_                        NUMBER(19)         NOT NULL,
  VERSION_                   NUMBER(10)         NOT NULL,
  NAME_                      VARCHAR2(255 CHAR)     NULL,
  START_                     TIMESTAMP(6)           NULL,
  END_                       TIMESTAMP(6)           NULL,
  NODEENTER_                 TIMESTAMP(6)           NULL,
  NEXTLOGINDEX_              NUMBER(10)             NULL,
  ISABLETOREACTIVATEPARENT_  NUMBER(1)              NULL,
  ISTERMINATIONIMPLICIT_     NUMBER(1)              NULL,
  ISSUSPENDED_               NUMBER(1)              NULL,
  NODE_                      NUMBER(19)             NULL,
  PROCESSINSTANCE_           NUMBER(19)             NULL,
  PARENT_                    NUMBER(19)             NULL,
  SUBPROCESSINSTANCE_        NUMBER(19)             NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TOKENVARIABLEMAP
(
  ID_               NUMBER(19)                  NOT NULL,
  TOKEN_            NUMBER(19)                      NULL,
  CONTEXTINSTANCE_  NUMBER(19)                      NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_TRANSITION
(
  ID_                 NUMBER(19)                NOT NULL,
  NAME_               VARCHAR2(255 CHAR)            NULL,
  PROCESSDEFINITION_  NUMBER(19)                    NULL,
  FROM_               NUMBER(19)                    NULL,
  TO_                 NUMBER(19)                    NULL,
  FROMINDEX_          NUMBER(10)                    NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_VARIABLEACCESS
(
  ID_              NUMBER(19)                   NOT NULL,
  VARIABLENAME_    VARCHAR2(255 CHAR)               NULL,
  ACCESS_          VARCHAR2(255 CHAR)               NULL,
  MAPPEDNAME_      VARCHAR2(255 CHAR)               NULL,
  PROCESSSTATE_    NUMBER(19)                       NULL,
  TASKCONTROLLER_  NUMBER(19)                       NULL,
  INDEX_           NUMBER(10)                       NULL,
  SCRIPT_          NUMBER(19)                       NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


CREATE TABLE JBPM_VARIABLEINSTANCE
(
  ID_                NUMBER(19)                 NOT NULL,
  CLASS_             CHAR(1 CHAR)               NOT NULL,
  NAME_              VARCHAR2(255 CHAR)             NULL,
  CONVERTER_         CHAR(1 CHAR)                   NULL,
  TOKEN_             NUMBER(19)                     NULL,
  TOKENVARIABLEMAP_  NUMBER(19)                     NULL,
  PROCESSINSTANCE_   NUMBER(19)                     NULL,
  BYTEARRAYVALUE_    NUMBER(19)                     NULL,
  DATEVALUE_         TIMESTAMP(6)                   NULL,
  DOUBLEVALUE_       FLOAT(126)                     NULL,
  LONGIDCLASS_       VARCHAR2(255 CHAR)             NULL,
  LONGVALUE_         NUMBER(19)                     NULL,
  STRINGIDCLASS_     VARCHAR2(255 CHAR)             NULL,
  STRINGVALUE_       VARCHAR2(255 CHAR)             NULL,
  TASKINSTANCE_      NUMBER(19)                     NULL
)
LOGGING 
NOCACHE
NOPARALLEL
MONITORING;


ALTER TABLE BPM_DATABASE_PROPERTY ADD (
  PRIMARY KEY (DBP_ID));

ALTER TABLE BPM_DOCUMENT ADD (
  PRIMARY KEY (DOC_ID),
  UNIQUE (DOC_FS_PATH));

ALTER TABLE BPM_FILE_SYSTEM ADD (
  PRIMARY KEY (FIL_ID));

ALTER TABLE BPM_PROC_DEF_PROPERTIES ADD (
  CONSTRAINT BPM_PROCESS__PK PRIMARY KEY (PDP_ID),
  CONSTRAINT BPM_PDP_UK UNIQUE (PDP_PROCESS_DEFINITION_ID, PDP_NAME));

ALTER TABLE BPM_PROCESS_DEFINITION_ROLES ADD (
  PRIMARY KEY (PDR_ID));

ALTER TABLE BPM_PROCESS_DEFINTION_ROLES ADD (
  PRIMARY KEY (PDR_ID));

ALTER TABLE BPM_PROCESS_FILE ADD (
  PRIMARY KEY (PRO_ID));

ALTER TABLE BPM_ROLE ADD (
  PRIMARY KEY (ROL_ID),
  UNIQUE (ROL_NAME));

ALTER TABLE BPM_SIGN ADD (
  PRIMARY KEY (SIG_ID),
  UNIQUE (SIG_FS_PATH));

ALTER TABLE BPM_USER_INTERFACE ADD (
  PRIMARY KEY (USI_ID));

ALTER TABLE BPM_USER_INTERFACE_CLASS ADD (
  PRIMARY KEY (USC_ID));

ALTER TABLE JBPM_BYTEARRAY ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_BYTEBLOCK ADD (
  PRIMARY KEY (PROCESSFILE_, INDEX_));

ALTER TABLE JBPM_DELEGATION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_EXCEPTIONHANDLER ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_ID_GROUP ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_ID_USER ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TASKCONTROLLER ADD (
  PRIMARY KEY (ID_));

ALTER TABLE BPM_ACCESS_LOG ADD (
  PRIMARY KEY (ACC_ID));

ALTER TABLE BPM_PERMISSION ADD (
  PRIMARY KEY (PER_ROL_ID, PER_DOC_ID));

ALTER TABLE JBPM_ID_MEMBERSHIP ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_ACTION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_COMMENT ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_DECISIONCONDITIONS ADD (
  PRIMARY KEY (DECISION_, INDEX_));

ALTER TABLE JBPM_EVENT ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_LOG ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_MESSAGE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_MODULEDEFINITION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_MODULEINSTANCE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_NODE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_POOLEDACTOR ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_PROCESSDEFINITION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_PROCESSINSTANCE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_RUNTIMEACTION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_SWIMLANE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_SWIMLANEINSTANCE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TASK ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TASKACTORPOOL ADD (
  PRIMARY KEY (TASKINSTANCE_, POOLEDACTOR_));

ALTER TABLE JBPM_TASKINSTANCE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TIMER ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TOKEN ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TOKENVARIABLEMAP ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_TRANSITION ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_VARIABLEACCESS ADD (
  PRIMARY KEY (ID_));

ALTER TABLE JBPM_VARIABLEINSTANCE ADD (
  PRIMARY KEY (ID_));

ALTER TABLE BPM_SIGN ADD (
  CONSTRAINT FKD8C6CC3DAA02D8B3 FOREIGN KEY (SIG_DOC_ID) 
    REFERENCES BPM_DOCUMENT (DOC_ID));

ALTER TABLE JBPM_ID_GROUP ADD (
  CONSTRAINT FK_ID_GRP_PARENT FOREIGN KEY (PARENT_) 
    REFERENCES JBPM_ID_GROUP (ID_));

ALTER TABLE JBPM_TASKCONTROLLER ADD (
  CONSTRAINT FK_TSKCTRL_DELEG FOREIGN KEY (TASKCONTROLLERDELEGATION_) 
    REFERENCES JBPM_DELEGATION (ID_));

ALTER TABLE BPM_ACCESS_LOG ADD (
  CONSTRAINT FK2E58C4492B303B24 FOREIGN KEY (ACC_ROLE_ID) 
    REFERENCES BPM_ROLE (ROL_ID),
  CONSTRAINT FK2E58C44963B99703 FOREIGN KEY (ACC_DOC_ID) 
    REFERENCES BPM_DOCUMENT (DOC_ID));

ALTER TABLE BPM_PERMISSION ADD (
  CONSTRAINT FK537CC84FF2C1B6E7 FOREIGN KEY (PER_DOC_ID) 
    REFERENCES BPM_DOCUMENT (DOC_ID),
  CONSTRAINT FK537CC84F1EB80A4B FOREIGN KEY (PER_ROL_ID) 
    REFERENCES BPM_ROLE (ROL_ID));

ALTER TABLE JBPM_ID_MEMBERSHIP ADD (
  CONSTRAINT FK_ID_MEMSHIP_GRP FOREIGN KEY (GROUP_) 
    REFERENCES JBPM_ID_GROUP (ID_),
  CONSTRAINT FK_ID_MEMSHIP_USR FOREIGN KEY (USER_) 
    REFERENCES JBPM_ID_USER (ID_));

ALTER TABLE JBPM_ACTION ADD (
  CONSTRAINT FK_ACTION_ACTNDEL FOREIGN KEY (ACTIONDELEGATION_) 
    REFERENCES JBPM_DELEGATION (ID_),
  CONSTRAINT FK_ACTION_EVENT FOREIGN KEY (EVENT_) 
    REFERENCES JBPM_EVENT (ID_),
  CONSTRAINT FK_ACTION_EXPTHDL FOREIGN KEY (EXCEPTIONHANDLER_) 
    REFERENCES JBPM_EXCEPTIONHANDLER (ID_),
  CONSTRAINT FK_ACTION_REFACT FOREIGN KEY (REFERENCEDACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_CRTETIMERACT_TA FOREIGN KEY (TIMERACTION_) 
    REFERENCES JBPM_ACTION (ID_));

ALTER TABLE JBPM_COMMENT ADD (
  CONSTRAINT FK_COMMENT_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_COMMENT_TSK FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_));

ALTER TABLE JBPM_DECISIONCONDITIONS ADD (
  CONSTRAINT FK_DECCOND_DEC FOREIGN KEY (DECISION_) 
    REFERENCES JBPM_NODE (ID_));

ALTER TABLE JBPM_EVENT ADD (
  CONSTRAINT FK_EVENT_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_),
  CONSTRAINT FK_EVENT_TASK FOREIGN KEY (TASK_) 
    REFERENCES JBPM_TASK (ID_));

ALTER TABLE JBPM_LOG ADD (
  CONSTRAINT FK_LOG_ACTION FOREIGN KEY (ACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_LOG_CHILDTOKEN FOREIGN KEY (CHILD_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_LOG_DESTNODE FOREIGN KEY (DESTINATIONNODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_LOG_NEWBYTES FOREIGN KEY (NEWBYTEARRAY_) 
    REFERENCES JBPM_BYTEARRAY (ID_),
  CONSTRAINT FK_LOG_NODE FOREIGN KEY (NODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_LOG_OLDBYTES FOREIGN KEY (OLDBYTEARRAY_) 
    REFERENCES JBPM_BYTEARRAY (ID_),
  CONSTRAINT FK_LOG_PARENT FOREIGN KEY (PARENT_) 
    REFERENCES JBPM_LOG (ID_),
  CONSTRAINT FK_LOG_SOURCENODE FOREIGN KEY (SOURCENODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_LOG_SWIMINST FOREIGN KEY (SWIMLANEINSTANCE_) 
    REFERENCES JBPM_SWIMLANEINSTANCE (ID_),
  CONSTRAINT FK_LOG_TASKINST FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_),
  CONSTRAINT FK_LOG_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_LOG_TRANSITION FOREIGN KEY (TRANSITION_) 
    REFERENCES JBPM_TRANSITION (ID_),
  CONSTRAINT FK_LOG_VARINST FOREIGN KEY (VARIABLEINSTANCE_) 
    REFERENCES JBPM_VARIABLEINSTANCE (ID_));

ALTER TABLE JBPM_MESSAGE ADD (
  CONSTRAINT FK_CMD_ACTION FOREIGN KEY (ACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_CMD_NODE FOREIGN KEY (NODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_CMD_TASKINST FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_),
  CONSTRAINT FK_MSG_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_));

ALTER TABLE JBPM_MODULEDEFINITION ADD (
  CONSTRAINT FK_MODDEF_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_),
  CONSTRAINT FK_TSKDEF_START FOREIGN KEY (STARTTASK_) 
    REFERENCES JBPM_TASK (ID_));

ALTER TABLE JBPM_MODULEINSTANCE ADD (
  CONSTRAINT FK_MODINST_PRCINST FOREIGN KEY (PROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_),
  CONSTRAINT FK_TASKMGTINST_TMD FOREIGN KEY (TASKMGMTDEFINITION_) 
    REFERENCES JBPM_MODULEDEFINITION (ID_));

ALTER TABLE JBPM_NODE ADD (
  CONSTRAINT FK_DECISION_DELEG FOREIGN KEY (DECISIONDELEGATION) 
    REFERENCES JBPM_DELEGATION (ID_),
  CONSTRAINT FK_NODE_ACTION FOREIGN KEY (ACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_NODE_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_),
  CONSTRAINT FK_NODE_SUPERSTATE FOREIGN KEY (SUPERSTATE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_PROCST_SBPRCDEF FOREIGN KEY (SUBPROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_));

ALTER TABLE JBPM_POOLEDACTOR ADD (
  CONSTRAINT FK_POOLEDACTOR_SLI FOREIGN KEY (SWIMLANEINSTANCE_) 
    REFERENCES JBPM_SWIMLANEINSTANCE (ID_));

ALTER TABLE JBPM_PROCESSDEFINITION ADD (
  CONSTRAINT FK_PROCDEF_STRTSTA FOREIGN KEY (STARTSTATE_) 
    REFERENCES JBPM_NODE (ID_));

ALTER TABLE JBPM_PROCESSINSTANCE ADD (
  CONSTRAINT FK_PROCIN_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_),
  CONSTRAINT FK_PROCIN_ROOTTKN FOREIGN KEY (ROOTTOKEN_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_PROCIN_SPROCTKN FOREIGN KEY (SUPERPROCESSTOKEN_) 
    REFERENCES JBPM_TOKEN (ID_));

ALTER TABLE JBPM_RUNTIMEACTION ADD (
  CONSTRAINT FK_RTACTN_ACTION FOREIGN KEY (ACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_RTACTN_PROCINST FOREIGN KEY (PROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_));

ALTER TABLE JBPM_SWIMLANE ADD (
  CONSTRAINT FK_SWL_ASSDEL FOREIGN KEY (ASSIGNMENTDELEGATION_) 
    REFERENCES JBPM_DELEGATION (ID_),
  CONSTRAINT FK_SWL_TSKMGMTDEF FOREIGN KEY (TASKMGMTDEFINITION_) 
    REFERENCES JBPM_MODULEDEFINITION (ID_));

ALTER TABLE JBPM_SWIMLANEINSTANCE ADD (
  CONSTRAINT FK_SWIMLANEINST_SL FOREIGN KEY (SWIMLANE_) 
    REFERENCES JBPM_SWIMLANE (ID_),
  CONSTRAINT FK_SWIMLANEINST_TM FOREIGN KEY (TASKMGMTINSTANCE_) 
    REFERENCES JBPM_MODULEINSTANCE (ID_));

ALTER TABLE JBPM_TASK ADD (
  CONSTRAINT FK_TASK_ASSDEL FOREIGN KEY (ASSIGNMENTDELEGATION_) 
    REFERENCES JBPM_DELEGATION (ID_),
  CONSTRAINT FK_TASK_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_),
  CONSTRAINT FK_TASK_STARTST FOREIGN KEY (STARTSTATE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_TASK_SWIMLANE FOREIGN KEY (SWIMLANE_) 
    REFERENCES JBPM_SWIMLANE (ID_),
  CONSTRAINT FK_TASK_TASKMGTDEF FOREIGN KEY (TASKMGMTDEFINITION_) 
    REFERENCES JBPM_MODULEDEFINITION (ID_),
  CONSTRAINT FK_TASK_TASKNODE FOREIGN KEY (TASKNODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_TSK_TSKCTRL FOREIGN KEY (TASKCONTROLLER_) 
    REFERENCES JBPM_TASKCONTROLLER (ID_));

ALTER TABLE JBPM_TASKACTORPOOL ADD (
  CONSTRAINT FK_TASKACTPL_TSKI FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_),
  CONSTRAINT FK_TSKACTPOL_PLACT FOREIGN KEY (POOLEDACTOR_) 
    REFERENCES JBPM_POOLEDACTOR (ID_));

ALTER TABLE JBPM_TASKINSTANCE ADD (
  CONSTRAINT FK_TASKINST_SLINST FOREIGN KEY (SWIMLANINSTANCE_) 
    REFERENCES JBPM_SWIMLANEINSTANCE (ID_),
  CONSTRAINT FK_TASKINST_TASK FOREIGN KEY (TASK_) 
    REFERENCES JBPM_TASK (ID_),
  CONSTRAINT FK_TASKINST_TMINST FOREIGN KEY (TASKMGMTINSTANCE_) 
    REFERENCES JBPM_MODULEINSTANCE (ID_),
  CONSTRAINT FK_TASKINST_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_));

ALTER TABLE JBPM_TIMER ADD (
  CONSTRAINT FK_TIMER_ACTION FOREIGN KEY (ACTION_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_TIMER_PRINST FOREIGN KEY (PROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_),
  CONSTRAINT FK_TIMER_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_TIMER_TSKINST FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_));

ALTER TABLE JBPM_TOKEN ADD (
  CONSTRAINT FK_TOKEN_NODE FOREIGN KEY (NODE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_TOKEN_PARENT FOREIGN KEY (PARENT_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_TOKEN_PROCINST FOREIGN KEY (PROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_),
  CONSTRAINT FK_TOKEN_SUBPI FOREIGN KEY (SUBPROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_));

ALTER TABLE JBPM_TOKENVARIABLEMAP ADD (
  CONSTRAINT FK_TKVARMAP_CTXT FOREIGN KEY (CONTEXTINSTANCE_) 
    REFERENCES JBPM_MODULEINSTANCE (ID_),
  CONSTRAINT FK_TKVARMAP_TOKEN FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_));

ALTER TABLE JBPM_TRANSITION ADD (
  CONSTRAINT FK_TRANSITION_FROM FOREIGN KEY (FROM_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_TRANSITION_TO FOREIGN KEY (TO_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_TRANS_PROCDEF FOREIGN KEY (PROCESSDEFINITION_) 
    REFERENCES JBPM_PROCESSDEFINITION (ID_));

ALTER TABLE JBPM_VARIABLEACCESS ADD (
  CONSTRAINT FK_VARACC_PROCST FOREIGN KEY (PROCESSSTATE_) 
    REFERENCES JBPM_NODE (ID_),
  CONSTRAINT FK_VARACC_SCRIPT FOREIGN KEY (SCRIPT_) 
    REFERENCES JBPM_ACTION (ID_),
  CONSTRAINT FK_VARACC_TSKCTRL FOREIGN KEY (TASKCONTROLLER_) 
    REFERENCES JBPM_TASKCONTROLLER (ID_));

ALTER TABLE JBPM_VARIABLEINSTANCE ADD (
  CONSTRAINT FK_BYTEINST_ARRAY FOREIGN KEY (BYTEARRAYVALUE_) 
    REFERENCES JBPM_BYTEARRAY (ID_),
  CONSTRAINT FK_VARINST_PRCINST FOREIGN KEY (PROCESSINSTANCE_) 
    REFERENCES JBPM_PROCESSINSTANCE (ID_),
  CONSTRAINT FK_VARINST_TK FOREIGN KEY (TOKEN_) 
    REFERENCES JBPM_TOKEN (ID_),
  CONSTRAINT FK_VARINST_TKVARMP FOREIGN KEY (TOKENVARIABLEMAP_) 
    REFERENCES JBPM_TOKENVARIABLEMAP (ID_),
  CONSTRAINT FK_VAR_TSKINST FOREIGN KEY (TASKINSTANCE_) 
    REFERENCES JBPM_TASKINSTANCE (ID_));

ALTER TABLE JBPM_BYTEBLOCK ADD (
  CONSTRAINT FK_BYTEBLOCK_FILE FOREIGN KEY (PROCESSFILE_) 
    REFERENCES JBPM_BYTEARRAY (ID_));

  

create table JBPM_JOB
(
  ID_ 					NUMBER(19,0) 		NOT NULL ,
  CLASS_ 				CHAR(1 CHAR) NOT NULL ,
  VERSION_ 				NUMBER(10,0) NOT NULL ,
  DUEDATE_ 				TIMESTAMP (6),
  PROCESSINSTANCE_ 		NUMBER(19,0),
  TOKEN_ 				NUMBER(19,0),
  TASKINSTANCE_ 		NUMBER(19,0),
  ISSUSPENDED_ 			NUMBER(1,0),
  ISEXCLUSIVE_ 			NUMBER(1,0),
  LOCKOWNER_ 			VARCHAR2(255 CHAR),
  LOCKTIME_ 			TIMESTAMP (6),
  EXCEPTION_ 			VARCHAR2(4000 CHAR),
  RETRIES_ 				NUMBER(10,0),
  NAME_ 				VARCHAR2(255 CHAR),
  REPEAT_ 				VARCHAR2(255 CHAR),
  TRANSITIONNAME_ 		VARCHAR2(255 CHAR),
  ACTION_ 				NUMBER(19,0),
  GRAPHELEMENTTYPE_ 	VARCHAR2(255 CHAR),
  GRAPHELEMENT_ 		NUMBER(19,0),
  NODE_ 				NUMBER(19,0),
  PRIMARY KEY 			(ID_)
)
LOGGING
NOCACHE
NOPARALLEL;

alter table JBPM_MODULEINSTANCE add  VERSION_ number(10,0);
alter table JBPM_NODE add  DESCRIPTION_ varchar(4000 char);
alter table JBPM_NODE add  ISASYNCEXCL_ number(1,0);
alter table JBPM_NODE add  SUBPROCNAME_ varchar(255 char);
alter table JBPM_NODE add  SCRIPT_ number(19,0);
alter table JBPM_POOLEDACTOR add  VERSION_ number(10,0);
alter table JBPM_PROCESSDEFINITION add  CLASS_ char(1 char);
alter table JBPM_PROCESSDEFINITION add  DESCRIPTION_ varchar(4000 char);
alter table JBPM_PROCESSINSTANCE add  KEY_ varchar(255 char);
alter table JBPM_SWIMLANEINSTANCE add  VERSION_ number(10,0);
alter table JBPM_TASK add  CONDITION_ varchar(255 char);
alter table JBPM_TASK add  PRIORITY_ number(10,0);
alter table JBPM_TASKINSTANCE add  VERSION_ number(10,0);
alter table JBPM_TASKINSTANCE add  PROCINST_ number(19,0);
alter table JBPM_TOKEN add  LOCK_ varchar(255 char);
alter table JBPM_TOKENVARIABLEMAP add  VERSION_ number(10,0);
alter table JBPM_TRANSITION add  DESCRIPTION_ varchar(4000 char);
alter table JBPM_TRANSITION add  CONDITION_ varchar(255 char);
alter table JBPM_VARIABLEINSTANCE add  VERSION_ number(10,0);



drop table JBPM_MESSAGE;

create table JBPM_ID_ROLES (
  NAME_ VARCHAR2(255 CHAR),
  ROLES_ VARCHAR2(255 CHAR),
 constraint PK_JBPM_ID_ROLES_ primary key (NAME_, ROLES_)
);


